<?php
//-----------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: clase_usuario.php
// Desarrolladores: Juanan Ruiz (juanan@us.es)
//-----------------------------------------------------------------------------------
// Descripcion:  
// Gestiona el inicio de sesion de un usuario, graba los datos de un nuevo responsable
// en la base de datos y almacena los datos del usuario que accede a la aplicacion.
//-----------------------------------------------------------------------------------

class usuario {
	var $id_usuario;
	var $login;
	var $clave;
	var $nombre;
	var $apellidos;
	var $nif;
	var $correo;
	var $telefono;
	var $entidades = array();
	var $error;
	var $base_datos;
	var $entidades = array();
	
	function usuario($base_datos) {
		$this->base_datos = $base_datos;
		}

	//Busca los datos de un usuario en la base de datos en funcion de su identificador
	function obtener_datos ($id_usuario) {
		$consulta = "SELECT id_usuario, login, clave, nombre, apellidos, nif, correo, telefono FROM usuario WHERE id_usuario=" . $id_usuario;
		$this->base_datos->ejecutar_consulta($consulta);
		if ($this->base_datos->filas_implicadas > 0) {
		      	$this->base_datos->obtener_fila();
			$datos = $this->base_datos->fila;
			$this->id_usuario = $id_usuario;
			$this->login     = $datos["login"];
			$this->clave     = $datos["clave"];
			$this->nombre    = $datos["nombre"];
			$this->apellidos = $datos["apellidos"];
			$this->nif       = $datos["nif"];
			$this->correo    = $datos["correo"];
			$this->telefono  = $datos["telefono"];
			return true;
			}
		else {
			$this->error = "ERROR: No se encuentra el usuario en la base de datos";
			return false;
			}
	}

	//Devuelve un array con los identificadores de entidades a las que pertenece este usuario y los roles asociados
	//  rol 1 - administrador de sistema
	//  rol 2 - responsable de entidad
	//  rol 3 - responsable de indicador
	function obtener_entidades($id_usuario) {
		$consulta = "SELECT entidad.id_entidad as id_entidad, entidad.nombre as nombre_entidad, usuario_entidad.rol as rol";
		$consulta .= " FROM usuario_entidad INNER JOIN entidad ON usuario_entidad.id_entidad = entidad.id_entidad";
		$consulta .= " WHERE usuario_entidad.id_usuario=" . $id_usuario . " ORDER BY nombre_entidad";
		$this->base_datos->ejecutar_consulta($consulta);
		if ($this->base_datos->filas_implicadas > 0) {
		      	while ($this->base_datos->obtener_fila()) {
				$datos = $this->base_datos->fila;
				$this->entidades[$datos["id_entidad"]] = array("id_entidad"=>$datos["id_entidad"],"nombre"=> $datos["nombre_entidad"],"rol"=> $datos["rol"]);
				}
			//print_r ($this->entidades);
			return true;
			
			}
		else {
			$this->error = "AVISO: este usuario no tiene entidades asignadas";
			return false;
			}
		}
	
	//Comprueba login y clave, devuelve el identificador del usuario
	function comprobar_login($login,$clave) {
		$consulta = "SELECT id_usuario FROM usuario WHERE login='" . $login . "' AND clave='" . $clave . "'";
		$this->base_datos->ejecutar_consulta($consulta);
		if ($this->base_datos->filas_implicadas > 0) {
			$this->base_datos->obtener_fila();
			$id_usuario = $this->base_datos->fila["id_usuario"];
			return $id_usuario;
			}
		else {
			$this->error = "ERROR: el nombre de usuario o la clave son incorrectos.";
			return false;
			}
		
		}
		
	//Escribe los datos de un nuevo usuario en la base de datos
	function crear ($login, $clave, $nombre, $apellidos, $nif, $correo, $telefono, $id_entidad, $rol) {
		//Comprueba que no exista un usuario con el mismo login en el sistema
		$consulta = "SELECT * FROM usuario WHERE login='" . $login . "'";
		$this->base_datos->ejecutar_consulta($consulta);
		if ($this->base_datos->filas_implicadas > 0) {
			$this->error = "ERROR: el nombre de usuario '" . $login . "' ya existe en el sistema";
			return false;
			}
		
	        //Si el login no esta repetido grabamos el nuevo usuario
		$consulta = "INSERT INTO usuario (nombre,apellidos,nif,login,clave,correo, telefono)  VALUES ('";
		$consulta .= $nombre . "','" . $apellidos . "','" . $nif . "','" . $login . "','" . $clave . "','" . $correo . "','" . $telefono . "' )";
		$this->base_datos->ejecutar_consulta($consulta);
		
		if ($this->base_datos->filas_implicadas > 0){
			//Obtenemos el identificador del nuevo usuario
			$this->id_usuario = $this->base_datos->obtener_ultima_id();
			//Grabamos las entidad que se le ha asignado
			$consulta = "INSERT INTO usuario_entidad (id_usuario, id_entidad, rol) ";
			$consulta .= "VALUES (" . $this->id_usuario . "," . $id_entidad . ",'" . $rol ."')";
			$this->base_datos->ejecutar_consulta($consulta);
			//echo $consulta;
			if ($this->base_datos->filas_implicadas>0) { 
				$this->entidades[] = $id_entidad;
			    }			
			return true;
			}
		else {
			$this->error = "ERROR: No ha podido grabarse el nuevo usuario en el sistema.";
			return false;
			}
	}

	function actualizar_datos($id_usuario,$nombre,$apellidos,$nif,$correo,$telefono,$login,$clave,$id_entidad,$rol) {	
		//Comprueba que no exista un usuario con el mismo login en el sistema
		$consulta = "SELECT * FROM usuario WHERE login='" . $login . "' AND id_usuario <> " . $id_usuario ;
		$this->base_datos->ejecutar_consulta($consulta);
		if ($this->base_datos->filas_implicadas > 0) {
			$this->error = "ERROR: el nombre de usuario '" . $login . "' ya existe en el sistema";
			return false;
			}
		// Modificamos los datos relativos al usuario
      		$consulta = "UPDATE usuario SET ";
      		$consulta .= "login='" . $login . "',";
      		$consulta .= "clave='" . $clave . "',";
      		$consulta .= "nombre='" . $nombre . "',";
      		$consulta .= "apellidos='" . $apellidos . "',";
      		$consulta .= "nif='" . $nif . "',";
      		$consulta .= "correo='" . $correo . "',";
		$consulta .= "telefono='" . $telefono . "' ";
      		$consulta .= "WHERE id_usuario = " . $id_usuario;
      
		$this->base_datos->ejecutar_consulta($consulta);

		// Modificamos los datos relativos a la entidad
		$consulta = "UPDATE usuario_entidad SET ";
		$consulta .= "rol='" . $rol . "' ";
		$consulta .= "WHERE id_usuario=" . $id_usuario . " AND id_entidad=" . $id_entidad;
		
		$this->base_datos->ejecutar_consulta($consulta);
		
        	return true;
	 }
}
?>
