<?php 
// -----------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: formulario_usuario_entidad.php
// Tipo: interfaz de usuario
// Desarrolladores: Juanan Ruiz (juanan@us.es)
// -----------------------------------------------------------------------------------------------
// Descripcion: Formulario para cambiar o agregar entidades a un usuario
// Envia a: graba_usuario_entidad.php
// -----------------------------------------------------------------------------------------------

include_once ("icasus.config.php");
include_once ("clase_base_datos.php");
include_once ("clase_entidad.php");
include_once ("clase_usuario.php");
include_once ("clase_ica.php");

session_start(); // habilita variables de sesion

// Comprueba si el usuario ha iniciado sesion
if (!isset($_SESSION["usuario"])) {
	header ("Location: index.php?aviso=Debe iniciar sesion");
	}
	
// Comprueba que el rol del usuario sea de administrador del sistema para permitirle acceder a esta pagina
if ($_SESSION["usuario"]->entidades[0]["rol"]!="administrador") {
	header ("Location:lista_entidades.php?aviso=Permisos insuficientes para modificar entidades");
	}
	
// Comprueba las variables requeridas de la pagina anterior
if (isset($_GET["id_usuario"])) {
	$id_usuario_editado = $_GET["id_usuario"];
	$base_datos = new base_datos($ic_db_host,$ic_db_login,$ic_db_clave,$ic_db_database);
	$usuario = new usuario($base_datos);
	$usuario->obtener_datos($id_usuario_editado);
	$usuario->obtener_entidades($id_usuario_editado);
	}
else {
	header ("Location:lista_entidades.php?aviso=Debe seleccionar un usuario");
	}

// Variables de sesion
// TODO2: Cambiar id_usuario por id_operario etc
$id_usuario = $_SESSION["usuario"]->id_usuario;
$login_usuario = $_SESSION["usuario"]->login;

// Datos de la pagina
$nombre_pagina = "Asignaci&oacute;n de ediciones a " . $usuario->nombre . " " . $usuario->apellidos;
$comandos = $ic_cmd_usuarios . $ic_cmd_entidades;

$javascript = "<script type='text/javascript'>
   // Comprueba los datos del formulario para agregar entidades
   function compruebaDatos(){
      if (document.formagregar == '') { 
       	alert('Debe elegir una entidad');
	return(false);
	}
      else {
        document.formagregar.submit();
	}
    
    function confirmar_borrado(destino) {
	if (confirm('?Esta seguro de eliminar esta entidad para este usuario?')) {
	    document.location = destino;
	    }
	}

    function cambia_rol() {
        document.location = destino;
	}
   
   </script>";

//Comienzo a desplegar codigo html
include_once ("inc_cabecera.php"); 
?>
<h2>Entidades actuales</h2>
<form action="graba_usuario_entidad.php" method="post" id="formodifica" name="formodifica">

<?php
foreach ($usuario->entidades as $entidad) {
	$enlace_borrar = "graba_usuario_entidad.php?id_usuario=" . $usuario->id_usuario . "&id_entidad=" . $entidad["id_entidad"] . "&modo=eliminar";
	$lista_entidades .= "<tr><td>" . $entidad["nombre"] . "</td>";
	$lista_entidades .= "<td><select id='rol" . $entidad["id_entidad"] . "' name='rol" . $entidad["id_entidad"] . "' onchange='javascript:cambia_rol()'>\n";
	$lista_entidades .= "<option value='usuario' ";
	if ($entidad["rol"] == "usuario") $lista_entidades .= "selected";
	$lista_entidades .= ">Usuario</option>\n";
	$lista_entidades .= "<option value ='administrador' ";
	if ($entidad["rol"] == "administrador") $lista_entidades .= "selected"; 
	$lista_entidades .= ">Administrador</option>\n";
	$lista_entidades .= "</select></td>";
	$lista_entidades .= "<td><a href='javascript:confirmar_borrado($enlace_borrar)'>Eliminar</a></td></tr>\n";
	}
	
if ($lista_entidades <> "") { 
	print("<table>" . $lista_entidades . "</table>");
	}
else
	print("<h4>Sin entidades asignadas</h4>");
?>

</form>

<h2>Agregar entidad</h2>

<?php 
include_once ("inc_pie.php"); 
$base_datos->desconectar();
?>
