<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: graba_usuario.php
// Tipo: proceso e interfaz de usuario
// Desarrolladores: Juanan Ruiz (juanan@us.es)
//---------------------------------------------------------------------------------------------------
// Descripcion: Graba los datos de un nuevo usuario recogidos desde form_indicador.php y muestra 
// el resultado al usuario 
//---------------------------------------------------------------------------------------------------

include_once ("icasus.config.php");
include_once ("clase_usuario.php");
include_once ("clase_base_datos.php");

//Habilita variables de sesion
session_start();

// Comprueba si el usuario ha iniciado sesion
if (!isset($_SESSION["usuario"]))
	header ("Location: index.php?aviso=Debe iniciar sesion");

//Comprueba que todas las variables obligatorias traigan contenido y si no redirecciona al formulario
if (empty($_POST["nombre"]) || empty($_POST["apellidos"]) || empty($_POST["login"])|| empty($_POST["clave"]) )
	header ("Location: formulario_usuario.php");

//Variables de sesion
$id_usuario = $_SESSION["usuario"]->id_usuario;
$login_usuario = $_SESSION["usuario"]->login;
$operario = $_SESSION["usuario"]; 

// Variables que vienen de la pagina anterior
if (isset($_POST["id_usuario"])) {
	$id_usuario_editado = $_POST["id_usuario"];
	}
$nombre = $_POST["nombre"];
$apellidos = $_POST["apellidos"];
$nif = $_POST["nif"];
$correo = $_POST["correo"];
$telefono = $_POST["telefono"];
$login = $_POST["login"];
$clave = $_POST["clave"];
$id_entidad = $_POST["entidad"]; 
$rol = $_POST["rol"];

$base_datos = new base_datos($ic_db_host,$ic_db_login,$ic_db_clave,$ic_db_database);
$usuario = new usuario($base_datos);

// Si el id_usuario_editado viene lleno es un usuario existente y editamos
// si  viene vacio es un usuario nuevo y lo creamos,
if (isset($id_usuario_editado)) {
    // Actualiza los datos del usuario	
    if ($usuario->actualizar_datos($id_usuario_editado,$nombre, $apellidos, $nif, $correo, $telefono, $login, $clave,$id_entidad,$rol)) {
    	$mensaje = "El usuario se ha actualizado correctamente";
	// Obtenemos los datos actualizados del usuario para imprimirlos en pantalla
	$usuario->obtener_datos($id_usuario_editado);
	$html_usuario = "<h3>Datos del usuario</h3>\n<table>";
	$html_usuario .= "<tr><th>Login</th><td>" . $usuario->login  . "</td></tr>\n";
	$html_usuario .= "<tr><th>Nombre</th><td>" . $usuario->nombre . "</td></tr>\n";	
	$html_usuario .= "<tr><th>Apellidos</th><td>" . $usuario->apellidos . "</td></tr>\n";	
	$html_usuario .= "<tr><th>DNI</th><td>" . $usuario->nif . "</td></tr>\n";	
	$html_usuario .= "<tr><th>Correo</th><td>" . $usuario->correo . "</td></tr>\n";	
	$html_usuario .= "<tr><th>Tel&eacute;fono</th><td>" . $usuario->telefono . "</td></tr>\n";	
	$html_usuario .= "</table>";
	// Mostramos las entidades asignadas a este usuario
	$usuario->obtener_entidades($id_usuario_editado);
	$html_entidades = "<h3>Entidades asignadas</h3>\n<table class='listing' id='sortable'><thead>\n";
	$html_entidades .= "<th>Entidad</th><th>Rol</th></thead><tbody>";
	foreach ($usuario->entidades as $entidad_usuario) {
		$html_entidades .= "<tr><td>". $entidad_usuario["nombre"] . "</td>";
		$html_entidades .= "<td>" . $entidad_usuario["rol"] . "</td></tr>\n";
		}
	$html_entidades .= "</tbody></table>\n";
	
	}
    else {
    	$mensaje = $usuario->error;
    	}
    }
else {
    // Graba el usuario 	
    if ($usuario->crear($login,$clave,$nombre,$apellidos,$nif,$correo,$telefono,$id_entidad,$rol)) {
  	$mensaje = "El usuario se ha grabado correctamente.";
	// Obtenemos el usuario que acabamos de grabar para imprimirlo en pantalla
	$usuario->obtener_datos($usuario->id_usuario);
	$html_usuario = "<h3>Datos del usuario</h3>\n<table>";
	$html_usuario .= "<tr><th>Login</th><td>" . $usuario->login  . "</td></tr>\n";
	$html_usuario .= "<tr><th>Nombre</th><td>" . $usuario->nombre . "</td></tr>\n";	
	$html_usuario .= "<tr><th>Apellidos</th><td>" . $usuario->apellidos . "</td></tr>\n";	
	$html_usuario .= "<tr><th>DNI</th><td>" . $usuario->nif . "</td></tr>\n";	
	$html_usuario .= "<tr><th>Correo</th><td>" . $usuario->correo . "</td></tr>\n";	
	$html_usuario .= "<tr><th>Tel&eacute;fono</th><td>" . $usuario->telefono . "</td></tr>\n";	
	$html_usuario .= "</table>";
	
	// Mostramos las entidades asignadas a este usuario
	$usuario->obtener_entidades($usuario->id_usuario);
	$html_entidades = "<h3>Entidades asignadas</h3>\n<table class='listing' id='sortable'><thead>\n";
	$html_entidades .= "<th>Entidad</th><th>Rol</th></thead><tbody>";
	foreach ($usuario->entidades as $entidad_usuario) {
		$html_entidades .= "<tr><td>". $entidad_usuario["nombre"] . "</td>";
		$html_entidades .= "<td>" . $entidad_usuario["rol"] . "</td></tr>\n";
		}
	$html_entidades .= "</tbody></table>\n";
	
	}
    else {
  	// Veamos cual ha sido el fallo
	$mensaje = $usuario->error;
  	}
    }

$base_datos->desconectar();

$nombre_pagina = "Datos Usuario: " . $usuario->nombre . " " . $usuario->apellidos;
$comandos = "";
//Comprobamos que el rol del usuario sea de administrador para asignarle botones de comandos avanzados
if ($operario->entidades[$id_entidad]["rol"]=="administrador" || $operario->entidades[0]["rol"]=="administrador") { 
	$comandos .= ic_cmd_editar_usuario($id_usuario_editado) . $ic_cmd_nuevo_usuario;
	}
$comandos .= $ic_cmd_usuarios . $ic_cmd_entidades;


// Comienzo a desplegar codigo html
include_once ("inc_cabecera.php"); 

print("<h2>Resultado de la operaci&oacute;n</h2>");

// Aqui imprimimos el resultado de la grabacion
print ("<p>".$mensaje."</p>");

print ($html_usuario);
print ($html_entidades);

include_once ("inc_pie.php"); 
?>
