<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: lista_usuarios.php
// Tipo: interfaz de usuarios
// Desarrolladores: Juanan Ruiz (juanan@us.es)
//---------------------------------------------------------------------------------------------------
// Descripcion: Muestra un listado de usuarios  de la entidad actual o del sistema completo
//---------------------------------------------------------------------------------------------------

include_once ("icasus.config.php");
include_once ("clase_base_datos.php");
include_once ("clase_usuario.php");
include_once ("clase_entidad.php");

//Habilita variables de sesion
session_start();

//Comprueba si el usuario ha iniciado sesion
if (!isset($_SESSION["usuario"]))
	header ("Location: index.php?aviso=Debe iniciar sesion para acceder al sistema");

$id_usuario = $_SESSION["usuario"]->id_usuario;
$login_usuario = $_SESSION["usuario"]->login;

//Instancia los objetos que vamos a necesitar	
$base_datos = new base_datos($ic_db_host,$ic_db_login,$ic_db_clave,$ic_db_database);
$entidad = new entidad($base_datos);

// Si viene desde un listado de entidades cogemos el identificador de identidad que viene en la url
// Si viene desde otro sitio mostramos solo los usuarios de la entidad que nos indique la variable de sesion
if (isset($_GET["id_entidad"])){ 
	$id_entidad = $_GET["id_entidad"];
	}
else
	$id_entidad = $_SESSION["entidad"]->id_entidad;

$entidad->obtener_datos($id_entidad);
$_SESSION["entidad"] = $entidad;
$nombre_entidad = $entidad->nombre;

//Preparamos un array con la lista de usuarios
$lista_usuarios = $entidad->listar_usuarios();

$tabla_usuarios = "<table class='listing' id='sortable'><thead><tr><th>Login</th><th>Nombre</th><th>Apellidos</th><th>Correo</th><th>Rol</th></tr></thead>\n<tbody>\n";
foreach ($lista_usuarios as $usuario) {
   $correo = $usuario["correo"];
   $tabla_usuarios .= "<tr><td><a href=datos_usuario.php?id_usuario=" . $usuario["id_usuario"] . ">" . $usuario["login"] . "</a></td>";
   $tabla_usuarios .= "<td>" . $usuario["nombre"] . "</td><td> " . $usuario["apellidos"]  . "</td>" ;
   $tabla_usuarios .= "<td><a href='mailto:" . $correo . "'>". $correo ."</a></td>";
   $tabla_usuarios .= "<td>" . $usuario["rol"] . "</td>";
   $tabla_usuarios .= "</tr>\n";
   }
$tabla_usuarios .= "</tbody></table>\n";

//Empezamos a desplegar html
$nombre_pagina="Lista de usuarios";
$comandos = $ic_cmd_nuevo_usuario . $ic_cmd_entidades;

include_once ("inc_cabecera.php"); 

print("<h2>" . $nombre_pagina . "</h2>");
print($tabla_usuarios); 

include_once ("inc_pie.php"); 
?>
